unit IO;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls;

Type
  TIO = class(TComponent)
  private
    { Private-Deklarationen }
    Function GetPort (Index : Integer) : Byte;
    Procedure PutPort (Index : Integer; Data : Byte);
    Function GetPortW (Index : Integer) : Word;
    Procedure PutPortW (Index : Integer; DataW : Word);
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    {8-Bit Zugriff ber Port-Array}
    property Port [Index : Integer] : Byte
      Read GetPort
      Write PutPort;
    {16-Bit Zugriff ber Port-Array}
    property PortW [Index : Integer] : Word
      Read GetPortW
      Write PutPortW;

    constructor create(AOwner: TComponent);override;

  published
    { Published-Deklarationen }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Zustzlich', [TIO]);
end;

{TIO}

constructor TIO.create(AOwner: TComponent);
begin
  inherited create(AOwner);
end;

Function TIO.GetPort(Index : Integer) : Byte;
Var
  Data : Byte;
  IOPort : Word;

Begin
  IOPort := Index;
  asm
    push dx
    push ax
    mov   dx,IOPort
    in al,dx
    mov Data,al
    pop ax
    pop dx
  end;
  GetPort := Data;
End;

Procedure TIO.PutPort(Index : Integer; Data : Byte);
Var
  IOPort : Word;

Begin
  IOPort := Index;
  asm
    push dx
    push ax
    mov al,Data
    mov   dx,IOPort
    out dx,al
    pop ax
    pop dx
  end;
End;

Function TIO.GetPortW(Index : Integer) : Word;
Var
  DataW,
  IOPort : Word;

Begin
  IOPort := Index;
  asm
    push dx
    push ax
    mov   dx,IOPort
    in ax,dx
    mov DataW,ax
    pop ax
    pop dx
  end;
  GetPortW := DataW;
End;

Procedure TIO.PutPortW(Index : Integer; DataW : Word);
Var
  IOPort : Word;

Begin
  IOPort := Index;
  asm
    push dx
    push ax
    mov ax,DataW
    mov   dx,IOPort
    out dx,ax
    pop ax
    pop dx
  end;
End;

end.
