unit P8255;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Port_io, ExtCtrls;

type
  TP8255_ = class(TComponent)
    P8255_: TPanel;
    PortA: TPort_IO;
    PortB: TPort_IO;
    PortC: TPort_IO;
    PortCtl: TPort_IO;
    Port_A: TEdit;
    Port_B: TEdit;
    Port_C: TEdit;
    Port_Ctl: TEdit;

  private
    { Private-Deklarationen }
    FPortBase : Word;
    FPortA: Word;
    FPortB: Word;
    FPortC: Word;
    FPortCtl: Word;
    FDataCtl : Byte;
    procedure SetPortBase (PortBase : Word);
    Function GetPortBase : Word;
    procedure PortOutA (Data : Byte);
    Function PortInA  : Byte;
    procedure PortOutB (Data : Byte);
    Function PortInB  : Byte;
    procedure PortOutC (Data : Byte);
    Function PortInC  : Byte;
    procedure PortOutCtl (Data : Byte);
    Function GetPort (Index : Integer) : Byte;
    Procedure PutPort (Index : Integer; Data : Byte);

  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    property Port [Index : Integer] : Byte
      Read GetPort
      Write PutPort;
    constructor create(AOwner: TComponent);override;

  published
    { Published-Deklarationen }
    property PortBase: Word read GetPortBase write SetPortBase;
    property DataA: Byte read PortInA write PortOutA;
    property DataB: Byte read PortInB write PortOutB;
    property DataC: Byte read PortInC write PortOutC;
    property DataCtl: Byte read FDataCtl write PortOutCtl;
    Property PA : Word Read FPortA Write FPortA;
    Property PB : Word Read FPortB Write FPortB;
    Property PC : Word Read FPortC Write FPortC;
    Property PCtl : Word Read FPortCtl Write FPortCtl;
  end;

procedure Register;

implementation


procedure Register;
begin
  RegisterComponents('System', [TP8255_]);
end;


(*
{TP8255_}
*)

procedure PortOut (Port : Word; Data : Byte);
Var
  IOPort : Word;

Begin
  IOPort := Port;
  asm
    push dx
    push ax
    mov al,Data
    mov   dx,IOPort
    out dx,al
    pop ax
    pop dx
  end;
End;

Function PortIn (Port : Word) : Byte;
Var
  Data : Byte;
  IOPort : Word;

Begin
  IOPort := Port;
  asm
    push dx
    push ax
    mov   dx,IOPort
    in al,dx
    mov Data,al
    pop ax
    pop dx
  end;
  PortIn := Data;
End;

Function TP8255_.GetPort(Index : Integer) : Byte;
Var
  Data : Byte;
  IOPort : Word;

Begin
  IOPort := Index;
  asm
    push dx
    push ax
    mov   dx,IOPort
    in al,dx
    mov Data,al
    pop ax
    pop dx
  end;
  GetPort := Data;
End;

Procedure TP8255_.PutPort(Index : Integer; Data : Byte);
Var
  IOPort : Word;

Begin
  IOPort := Index;
  asm
    push dx
    push ax
    mov al,Data
    mov   dx,IOPort
    out dx,al
    pop ax
    pop dx
  end;
End;

procedure TP8255_.SetPortBase (PortBase : Word);
Begin
  FPortA := PortBase;
  FPortB := FPortA + 1;
  FPortC := FPortB + 1;
  FPortCtl := FPortC + 1;
End;

Function TP8255_.GetPortBase : Word;
Begin
  GetPortBase := FPortBase;
End;

constructor TP8255_.create(AOwner: TComponent);
begin
  FPortBase := $300;
  FPortCtl := $9B;
  SetPortBase (FPortBase);
  asm
    push dx
    push ax
    mov al,FPortCtl
    mov   dx,FPortBase
    out dx,al
    pop ax
    pop dx
  end;
  inherited create(AOwner);
end;

Procedure TP8255_.PortOutA (Data : Byte);
Begin
  PortOut (FPortA,Data);
End;

Procedure TP8255_.PortOutB (Data : Byte);
Begin
  PortOut (FPortB,Data);
End;

Procedure TP8255_.PortOutC (Data : Byte);
Begin
  PortOut (FPortC,Data);
End;

Procedure TP8255_.PortOutCtl (Data : Byte);
Begin
  PortOut (FPortCtl,Data);
  FDataCtl := Data;
End;

Function TP8255_.PortInA : Byte;
Begin
  PortInA := PortIn (FPortA);
End;

Function TP8255_.PortInB : Byte;
Begin
  PortInB := PortIn (FPortB);
End;

Function TP8255_.PortInC : Byte;
Begin
  PortInC := PortIn (FPortC);
End;

end.
