unit Port_io;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls;

Type
  TPort_IO = class(TComponent)
  private
    { Private-Deklarationen }
    FPort: Word;
{
    FData: Word;
}
    procedure PortOut (Data : Byte);
    Function PortIn  : Byte;
    procedure PortOutW (DataW : Word);
    Function PortInW : Word;
    Function GetPort (Index : Integer) : Byte;
    Procedure PutPort (Index : Integer; Data : Byte);
    Function GetPortW (Index : Integer) : Word;
    Procedure PutPortW (Index : Integer; DataW : Word);
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    property Port [Index : Integer] : Byte
      Read GetPort
      Write PutPort;
    property PortW [Index : Integer] : Word
      Read GetPortW
      Write PutPortW;

    constructor create(AOwner: TComponent);override;

  published
    { Published-Deklarationen }
    property Data: Byte read PortIn write PortOut;
    property DataW: Word read PortInW write PortOutW;
    property PortAdr : Word Read FPort Write FPort;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('System', [TPort_IO]);
end;

{TPORT_IO}

constructor TPort_IO.create(AOwner: TComponent);
begin
  FPort := $300;
  inherited create(AOwner);
end;

procedure TPort_IO.PortOut (Data : Byte);
Var
  IOPort : Word;

Begin
  IOPort := FPort;
  asm
    push dx
    push ax
    mov al,Data
    mov   dx,IOPort
    out dx,al
    pop ax
    pop dx
  end;
End;

Function TPort_IO.PortIn : Byte;
Var
  Data : Byte;
  IOPort : Word;

Begin
  IOPort := FPort;
  asm
    push dx
    push ax
    mov   dx,IOPort
    in al,dx
    mov Data,al
    pop ax
    pop dx
  end;
  PortIn := Data;
End;

procedure TPort_IO.PortOutW (DataW : Word);
Var
  IOPort : Word;

Begin
  IOPort := FPort;
  asm
    push dx
    push ax
    mov ax,DataW
    mov   dx,IOPort
    out dx,ax
    pop ax
    pop dx
  end;
End;

Function TPort_IO.PortInW : Word;
Var
  DataW : Word;
  IOPort: Word;

Begin
  IOPort := FPort;
  asm
    push dx
    push ax
    mov   dx,IOPort
    in ax,dx
    mov DataW,ax
    pop ax
    pop dx
  end;
  PortInW := DataW;
End;

Function TPort_IO.GetPort(Index : Integer) : Byte;
Var
  Data : Byte;
  IOPort : Word;

Begin
  IOPort := Index;
  asm
    push dx
    push ax
    mov   dx,IOPort
    in al,dx
    mov Data,al
    pop ax
    pop dx
  end;
  GetPort := Data;
End;

Procedure TPort_IO.PutPort(Index : Integer; Data : Byte);
Var
  IOPort : Word;

Begin
  IOPort := Index;
  asm
    push dx
    push ax
    mov al,Data
    mov   dx,IOPort
    out dx,al
    pop ax
    pop dx
  end;
End;

Function TPort_IO.GetPortW(Index : Integer) : Word;
Var
  DataW,
  IOPort : Word;

Begin
  IOPort := Index;
  asm
    push dx
    push ax
    mov   dx,IOPort
    in ax,dx
    mov DataW,ax
    pop ax
    pop dx
  end;
  GetPortW := DataW;
End;

Procedure TPort_IO.PutPortW(Index : Integer; DataW : Word);
Var
  IOPort : Word;

Begin
  IOPort := Index;
  asm
    push dx
    push ax
    mov ax,DataW
    mov   dx,IOPort
    out dx,ax
    pop ax
    pop dx
  end;
End;

end.
